<template>
  <div>
    <Modal v-model="showModal" :mask-closable="false" width="1230">
      <p slot="header">{{modalTitle}}</p>
      <div>
        <Form id="edit-form" ref="formObj" :model="formObj" :rules="ruleValidate" :label-width="90" inline>

<!--          <Form-item label="委托方是否第一次送检" prop="firsted" class="width-48">-->
<!--            <Input v-model="formObj.firsted" name="firsted" placeholder="委托方是否第一次送检"/>-->
<!--          </Form-item>-->
          <Form-item label="委托方是否第一次送检" prop="firsted" class="width-48">
            <Radio-group v-model="formObj.firsted">
              <Radio v-for="item in judgeType" :key="item.value" :label="item.value">{{item.name}}</Radio>
            </Radio-group>
          </Form-item>
          <Form-item label="委托单位" prop="client" class="width-48">
            <Input v-model="formObj.client" name="client" placeholder="请输入委托单位"/>
          </Form-item>
          <Form-item label="联系人" prop="operation.person" class="width-48">
            <Input v-model="formObj.operation.person" name="operation.person" placeholder="请输入委托单位"/>
          </Form-item>
          <Form-item label="联系电话" prop="operation.tel" class="width-48">
            <Input v-model="formObj.operation.tel" name="operation.tel" placeholder="请输入委托单位"/>
          </Form-item>
          <Form-item label="传真" prop="operation.fax" class="width-48">
            <Input v-model="formObj.operation.fax" name="operation.fax" placeholder="请输入委托单位"/>
          </Form-item>
          <Form-item label="省、市、区" prop="name" class="width-48">
<!--            <Input v-model="formObj.client" name="name" placeholder="请输入委托单位"/>-->
            <CityNameCascader :value="testedCityData.join(',')" @on-result-change="_cascaderResult" name="tested">
            </CityNameCascader>
          </Form-item>
          <Form-item label="街道" prop="street" class="width-48">
            <Input v-model="formObj.street" name="street" placeholder="请输入委托单位"/>
          </Form-item>
          <Form-item label="邮编" prop="operation.postcode" class="width-48">
            <Input v-model="formObj.operation.postcode" name="operation.postcode" placeholder="请输入委托单位"/>
          </Form-item>

          <Form-item label="E-mail" prop="operation.email" class="width-48">
            <Input v-model="formObj.operation.email" name="operation.email" placeholder="请输入实验室名称"/>
          </Form-item>
          <Form-item label="委托日期：" prop="edate" class="width-48">
            <Input v-model="formObj.edate" name="edate" placeholder="请输入联系人"/>
          </Form-item>
          <Form-item label="合同号：" prop="contractCode" class="width-48">
            <Input v-model="formObj.contractCode" name="contractCode" placeholder="请输入联系人"/>
          </Form-item>
          <Form-item label="备注：" prop="remark" style="width: 99.8%">
            <Input v-model="formObj.remark" :rows="3" name="remark" type="textarea"
                   placeholder="请输入备注"/>
          </Form-item>
        </Form>
        <Col span="24">
          <!--          <btn-list :msg="btn" :open="searchOpen" :showSearchBtn="false" @on-result-change="_btnClick"-->
          <!--                    class="contHide"></btn-list>-->
          <Button @click="_add()" type="success">添加</Button>
        </Col>
        <Col span="24">
          <PTVXETable
            ref="pageTable"
            :form-id="formId"
            :table-height="500"
            :get-page="getPage"
            :icon-msg="iconMsg"
            @on-result-change="_tableResultChange">
            <vxe-table-column
              v-for="item in pageColumns"
              :key="item.key"
              :field="item.key"
              :title="item.title"
              :width="item.width"
              :min-width="200"
              :fixed="item.fixed?item.fixed:undefined"
              sortable
            >
              <template slot-scope="scope">
                <div v-if="item.key==='name'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.name" @on-result-change="_judgeBasisChange" @click.native="_selectjudgeBasis(scope.$rowIndex)" blur  placeholder="请输入或选择样品名称"
                  ></el-input>
                </div>
                <div v-if="item.key==='spec'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.spec" blur placeholder="请输入或选择型号规格"
                  ></el-input>
                </div>
                <div v-if="item.key==='factoryNumber'" @click.stop="_handleRow(scope)">
                  <el-input v-model="scope.row.factoryNumber" blur placeholder="请输入或选择出厂编号"
                  ></el-input>
                </div>
                <div v-if="item.key==='type'" @click.stop="_handleRow(scope)">
                  <Select v-model="scope.row.type">
                    <Option v-for="(item,index) in options" :key="item.name" :value="index">
                      {{ item.name }}
                    </Option>
                  </Select>
                </div>
                <div v-if="item.key==='quantity'" @click.stop="_handleRow(scope)">
                  <el-input
                    v-model="scope.row.quantity"
                    @keydown.native="channelInputLimit"
                    type="number"
                    placeholder="请输入或选择数量"
                  />
                </div>
              </template>
            </vxe-table-column>
          </PTVXETable>
        </Col>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult"></modal-footer>
      </div>
      <EditModal ref="EditModal" @on-result-change="_backData" is-change />
    </Modal>
  </div>
</template>
<script>
/**
 * 添加编辑分包商
 */
import { lmsBaseDict, meterEntrust } from '../../../api'
import CityNameCascader from '../../../components/base/CityNameCascader'
import EditModal from './EditModal'

export default {
  components: { EditModal, CityNameCascader },
  data() {
    return {
      formId: 'meterSendTestEditFormId',
      getPage: {
        records: []
      },
      testedCityData: [],
      testedTemp: {
        testedName: '',
        testedContactor: '',
        testedContactorTel: '',
        testedTel: '',
        testedProvince: '',
        testedCity: '',
        testedCounty: '',
        testedStreet: ''
      },
      judgeType: [{ value: 1, name: '是' }, { value: 0, name: '否' }],
      iconMsg: [
        {
          type: 'ios-clock',
          id: 'personal-task-meter-go-out-test-edit-edit-operation',
          name: '编辑'
        },
        {
          type: 'ios-clock',
          id: 'personal-task-meter-go-out-test-edit-remove-operation',
          name: '删除'
        }
      ],
      pageColumns: [
        { title: '样品名称', key: 'name', width: 160 },
        { title: '型号规格', key: 'spec' },
        { title: '出厂编号', key: 'factoryNumber' },
        { title: '检测类型', key: 'type' },
        { title: '数量', key: 'quantity' }
        // {title: '限制范围或说明', key: 'limitDescription'},
      ],
      options: [
        {
          name: '检定'
        },
        {
          name: '校准'
        },
        {
          name: '外观检查'
        }
      ],
      index: 0,
      id: '',
      modalTitle: '',
      subcontractorId: '',
      formObj: {
        firsted: 1,
        client: '',
        linkman: '',
        tel: '',
        email: '',
        address: '',
        remark: '',
        street: '',
        province: '',
        city: '',
        county: '',
        aptitude: [],
        assessFormSn: '',
        subArea: '',
        personCondition: '',
        edate: '',
        contractCode: '',
        operation: {
          person: '',
          tel: '',
          fax: '',
          postcode: '',
          email: '',
          fee: ''
        }
      },
      ruleValidate: {
        client: [
          { required: true, message: '委托单位不能为空', trigger: 'blur' }
        ]
      },
      clearingWayList: ['款到后测试', '先测试后付款', '其他情况（）'],
      clearingWayListTemp: ['款到后测试', '先测试后付款', '其他情况（）'],
      showModal: false,
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '保存', type: 'primary' }
      ],
      aptitudeData: []
    }
  },
  created() {
    this.$set(
      this.formObj,
      'tested',
      JSON.parse(JSON.stringify(this.testedTemp))
    )
  },
  methods: {
    _backData(data) {
      console.log(typeof this.index)
      this.getPage.records[this.index].name = data.name
      this.getPage.records[this.index].aptitudeId = data.id
      console.log('返回的数据')
      console.log(data)
      console.log(this.getPage.records)
    },
    _selectjudgeBasis(index) {
      console.log(index)
      this.index = index
      this.$refs.EditModal._open()
    },
    _cascaderResult(name, data, msg) {
      switch (name) {
        case 'cus':
          this._casChange(data, msg)
          break
        case 'tested':
          this._testedChange(data, msg)
          break
      }
    },
    _emptyProvince() {
      this.cityData = []
      this.testedCityData = []
      this.formObj.tested.testedProvince = ''
      this.formObj.tested.testedCity = ''
      this.formObj.tested.testedCounty = ''
    },
    _testedChange(data, msg) {
      // 省、市、区
      console.log('数据')
      console.log(data)
      console.log(msg)
      if (msg === 'clear') {
        this.formObj.tested.testedProvince = ''
        this.formObj.tested.testedCity = ''
        this.formObj.tested.testedCounty = ''
        this.formObj.province = ''
        this.formObj.city = ''
        this.formObj.county = ''
        this.testedCityData = []
      } else {
        this.formObj.tested.testedProvince = data.value[0]
        this.formObj.tested.testedCity = data.value[1]
        this.formObj.tested.testedCounty = data.value[2]

        this.formObj.province = data.value[0]
        this.formObj.city = data.value[1]
        this.formObj.county = data.value[2]
        this.testedCityData = [data.value[0], data.value[1], data.value[2]]
      }
    },
    _getJudgeBasisList(data) {
      const obj = { classify: 0 }
      if (data) {
        obj.stdNum = data
      }
      // this.$store.dispatch('StandardInfo/list', obj).then(() => {
      //   this.judgeBasisData = this.$store.state.StandardInfo.list
      // })
    },
    _judgeBasisChange(msg, data) {
      switch (msg) {
        case 'select':
          this.formObj.stdId = data.id
          this.formObj.code = data.stdNum
          this.formObj.name = data.name
          this.$refs.formObj.validateField('code')
          break
        case 'query':
          this.formObj.stdId = ''
          this.formObj.code = data.stdNum
          this.formObj.name = ''
          this._getJudgeBasisList(data.stdNum)
          break
        case 'focus':
          this._getJudgeBasisList()
          break
        case 'blur':
          if (this.formObj.stdId === '') {
            this.formObj.code = ''
            this._getJudgeBasisList()
          }
          this.$refs.formObj.validateField('code')
      }
    },
    _add() {
      const data = {
        name: '',
        spec: '',
        factoryNumber: '',
        quantity: '',
        type: ''
      }
      this.getPage.records.unshift(data)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          // this.getPage = this.$store.state.FoodJudgeBasis.page
          break
        case 'selectIds':
          // this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.rowIndex)
          break
        // case 'changeSize':
        //   this._page()
        //   break
      }
    },
    _iconClick(res, data, index) {
      switch (res) {
        case '编辑':
          // this._editModal(true, data.id)
          break
        case '删除':
          // this._deleteById(data.id)
          console.log('点击了删除按钮')
          console.log(index)
          this.getPage.records.splice(index, 1)
          break
        case '操作日志':
          // this._record(data.id)
          break
      }
    },
    _handleRow(data) {
      this.currentRow = data.row
      this.currentIndex = data.rowIndex
    },
    channelInputLimit(e) {
      const key = e.key
      // 不允许输入'e'和'.'
      if (key === 'e' || key === '.') {
        e.returnValue = false
        return false
      }
      return true
    },
    /** *modal-footer */
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '保存':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(msg) {
      this.showModal = false
      this.$Message.success(msg)
      this.$emit('on-result-change')
      this._hideLoading()
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          const data = this.$serialize('edit-form')
          Object.assign(this.formObj, data)
          if (this.$string(this.id).isEmpty()) {
            // 添加
            const saveData = this.formObj
            saveData.sampleList = this.getPage.records
            this._save(saveData)
          } else {
            const saveData = this.formObj
            saveData.sampleList = this.getPage.records
            // 编辑
            this._edit(saveData)
          }
        } else {
          this.$Message.error('表单验证失败!')
          this._hideLoading()
        }
      })
    },
    _wayResult(msg, data) {
      switch (msg) {
        case 'select':
          this.formObj.clearingWay = data
          break
        case 'query':
          this.formObj.clearingWay = data
          this._wayQuery(data)
          break
      }
    },
    _wayQuery(query) {
      if (query === '') {
        this.clearingWayList = this.clearingWayListTemp
      } else {
        this.clearingWayList = this.clearingWayListTemp.filter(
          item => item.indexOf(query) > -1
        )
      }
    },
    _cancel() {
      this.showModal = false
    },
    _open() {
      this.showModal = true
      this.$refs.formObj.resetFields()
      this._hideLoading()
      this.getPage.records = []
      this.id = ''
      this.modalTitle = '出检委托单登记'
    },

    _openEdit(formObj) {
      this.getPage.records = []
      this.showModal = true
      this.$refs.formObj.resetFields()
      this._hideLoading()
      this.id = ''
      this.modalTitle = '出检委托单编辑'
      this.id = formObj.id
      this.formObj = formObj
      this._showAddress(formObj)
      this.getPage.records = formObj.sampleList
    },
    _getAptitudeList: async function() {
      const result = await lmsBaseDict.getItem('subcontractorAptitude')
      if (result) {
        this.aptitudeData = result
      }
    },
    _showTime(formObj) {
      // 回显资质类型
      // if (formObj.aptitude !== undefined || '') {
      //   this.formObj.aptitude = formObj.aptitude.split(',')
      // } else {
      //   this.formObj.aptitude = []
      // }
    },
    _showAddress(formObj) {
      this.testedCityData = []
      if (
        formObj.province !== undefined &&
        formObj.city !== undefined &&
        formObj.county !== undefined
      ) {
        this.testedCityData.push(formObj.province)
        this.testedCityData.push(formObj.city)
        this.testedCityData.push(formObj.county)
      }
    },
    _save: async function(data) {
      const result = await meterEntrust.saveOutEntrust(data)
      console.log(result)
      if (result) {
        this._resultChange('添加成功!')
      }
    },
    _edit: async function(data) {
      const result = await meterEntrust.editDTO(data)
      if (result) {
        this._resultChange('编辑成功!')
      }
    }
  }
}
</script>
